Subject: Re: bug#42984: 27.1; package-list results in error while updating archive due to malformed path

From: Stefan Kangas <[email-masked]>
Date: Wed, 25 Nov 2020 01:32:26 -0800

Mirko Vukovic <[email-masked]> writes:

> This report mirrors the issue I submitted to Spacemacs as issue 13866. This issue
> has not received any replies yet. Since then I reproduced the issue with 'emacs -Q'
>
> Link to Spacemacs issue (with diagnostic and traceback info)
> - https://github.com/syl20bnr/spacemacs/issues/13866
>
> I run Emacs on MSYS2. On August 20, 2020, I refreshed MSYS2 packages
> and Emacs 27.1 was installed.
>
> This problem is generated with 'emacs -Q --debug-init':
> - no traceback info generated despite '--debug-init'
> - When Emacs comes up, execute command: 'package-list'
> - The package list comes up (it has 478 packages)
> - The *Error* buffer comes up with the following contents:
>
> Failed to verify signature archive-contents.sig:
> No public key for 066DAFCB81E42C40 created at 2020-08-22T05:05:02-0400 using RSA
> Command output:
> gpg: keyblock resource '/c/Users/977315/c:/Users/977315/.emacs.d/elpa/gnupg/pubring.kbx': No such file or directory
> gpg: Signature made Sat, Aug 22, 2020  5:05:02 AM EDT
> gpg:                using RSA key C433554766D3DDC64221BFAA066DAFCB81E42C40
> gpg: Can't check signature: No public key
>
> The offending file path consists of the current directory, followed by c:/Users/977315/.emacs.d/elpa/...
> I verified this by launching emacs from a different directory. That change would be reflected in the filepath, for example, when launched
> from the ~/tmp directory:
> gpg: keyblock resource '/c/Users/977315/tmp/c:/Users/977315/.emacs.d/elpa/gnupg/pubring.kbx': No such file or directory

I don't understand why this path is used.  It should be using:

    (expand-file-name "gnupg" package-user-dir)

What is the value of `package-gnupghome-dir' and `package-user-dir' on
your machine?